"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  CommitHashPlugin: () => CommitHashPlugin,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_child_process = require("child_process");
var import_fs = require("fs");
var import_pluginutils = require("@rollup/pluginutils");
var import_magic_string = __toESM(require("magic-string"));
var getCommit = () => {
  try {
    return encodeURIComponent(
      (0, import_child_process.execSync)("git describe --long --always --dirty --abbrev=10000").toString().trim()
    );
  } catch (error) {
    if (!(0, import_fs.existsSync)(".git")) {
      return ".git-not-found";
    } else {
      console.warn("nonfatal<git>: Git errored", error);
      return "unknown-commit";
    }
  }
};
var commit = getCommit();
var commitExpires = Date.now() + 1e4;
var virtualModuleId = "virtual:commit-hash";
var resolvedVirtualModuleId = "\0" + virtualModuleId;
var cachedCommitId = () => {
  if (Date.now() > commitExpires) {
    commit = getCommit();
    commitExpires = Date.now() + 1e4;
  }
  return commit;
};
var CommitHashPlugin = (config = { noPrefix: false, noVirtual: false }) => {
  const filter = (0, import_pluginutils.createFilter)(["**/*.js", "**/*.css"], null, {
    resolve: false
  });
  return {
    name: "ExponentialWorkload: Git Commit Hash",
    transform(code, id) {
      if (!filter(id))
        return null;
      const commit2 = cachedCommitId();
      const s = new import_magic_string.default(code);
      if (id.endsWith(".css")) {
        s.prepend(`/** Commit ${commit2} **/
`);
      } else if (id.endsWith(".js")) {
        s.prepend(`// Commit ${commit2}
`);
      }
      const map = s.generateMap({
        source: id,
        hires: true
      });
      return { code: s.toString(), map };
    },
    resolveId(id) {
      if (!config.noVirtual && id === virtualModuleId) {
        return resolvedVirtualModuleId;
      }
    },
    load(id) {
      if (!config.noVirtual && id === resolvedVirtualModuleId) {
        return `export const id = '${cachedCommitId()}';
export default id;
`;
      }
    }
  };
};
var src_default = CommitHashPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CommitHashPlugin
});
